# ./addons/eventscripts/whowasit/whowasit.py

import es
from cfglib import AddonCFG
from usermsg import saytext2

class WhoWasIt(object):
    def __init__(self):
        self.config    = None
        self.textCount = None
        self.players   = {} 

    def scriptLoad(self):
        self.config = AddonCFG(es.getAddonPath('whowasit') + '/whowasit_config.cfg')
        self.config.text('*****************************************')
        self.config.text('* Who Was It? by BackRaw - Configuration*')
        self.config.text('*****************************************')
        self.config.text('')
        self.textCount = self.config.cvar('whowasit_textcount', 3, 'How often can a player fool the others?')
        self.config.text('\n')
        self.config.text('*****************************************')
        self.config.text('* Who Was It? by BackRaw - Configuration*')
        self.config.text('*****************************************')
        self.config.write()
        self.executeConfig()
        for userid in es.getUseridList():
            self.insertUserid(userid)
        if not es.exists('saycommand', '!who'):
            es.regsaycmd('!who', 'whowasit/saycommand')
        es.ServerVar('whowasit_ver', 1.0, "BackRaw's Who Was It?").makepublic()

    def scriptUnload(self):
        self.removeUserid(clear=True)
        if es.exists('saycommand', '!who'):
            es.unregsaycmd('!who')

    def executeConfig(self):
        self.config.execute()

    def insertUserid(self, userid):
        self.players[int(userid)] = 0

    def removeUserid(self, userid=0, clear=False):
        if not clear:
            del self.players[int(userid)]
        else:
            self.players.clear()

    def resetPlayers(self):
        for userid in self.players:
            self.players[userid] = 0

    def sayCommand(self, userid, name, text):
        if not es.exists('userid', es.getuserid(name)):
            if self.players[userid] < int(self.textCount):
                self.players[userid] += 1
                player = es.createplayerlist(userid)[userid]
                what   = '#all' if not player['isdead'] else '#dead'
                saytext2(what, player['index'], '%s\x03%s \x01:  %s' % ('\x01*DEAD* ' if what == '#dead' else '', name, text))
            else:
                es.tell(userid, '#multi', "#green[#lightgreenWho Was It?#green] #defaultYou've exceeded the limit of 3 imitations per round.")
        else:
            es.tell(userid, '#multi', "#green[#lightgreenWho Was It?#green] #defaultYou can't imitate anybody!")
wwi = WhoWasIt()

def player_activate(ev):
    wwi.insertUserid(ev['userid'])

def player_disconnect(ev):
    wwi.removeUserid(ev['userid'])

def round_start(ev):
    wwi.resetPlayers()

def server_cvar(ev):
    if ev['cvarname'] == 'whowasit_textcount':
        wwi.executeConfig()

def saycommand():
    args = str(es.getargs()).split('-')
    wwi.sayCommand(int(es.getcmduserid()), args[0][:len(args[0]) - 1], args[1][1:])

def load():
    wwi.scriptLoad()

def unload():
    wwi.scriptUnload()